// =====================  GrLibPcx.cpp =====================
//
//   㭪樨 ⥭  䠩  뢮  ࠭ ࠦ
//    ଠ .PCX.
// ==========================================================


#include <stdio.h>
#include <alloc.h>
#include <dos.h>
#include <string.h>
#include <graphics.h>



// --------- ᪨ 樨  ᥫ ----------
#define COPY	     0x00
#define AND          0x01
#define OR           0x02
#define XOR          0x03

// -------- ॣ ᪮ ஫ -----------
#define GDC                  0x3CE
#define GDCReset             0x00
#define GDCEnable            0x01
#define GDCColorCompare      0x02
#define GDCDataRotate        0x03
#define GDCReadMapSel        0x04
#define GDCMode              0x05
#define GDCMisc              0x06
#define GDCColorDC           0x07
#define GDCBitMask           0x08


#define ByteOf(x,y)   ((y)*80 + ((x)>>3))	//浪  
#define EgaBase     0xA0000000L			//.  
#define MemoryOf(x,y) (unsigned char far*)(EgaBase+(long)ByteOf((x),(y)))

// -------  祭 v  ॣ r  c ---------
#define SetReg(c,r,v)  outportb((c),(r)); outportb((c+1),(v))

// --------  ᪨ ⮢ ( ॣ BitMask) ---------
#define SetMask(m)  SetReg(GDC, GDCBitMask, (m))




// -----------  䠩 ଠ .PCX -------------
struct PCXheader
{ char  manuf;		//ᥣ = 10  Paintbrush
  char  hard;		// 
  char  encod;		//稥 㯯 ஢ (=1)
  char  bitpx;		//-  ᪮   ᥫ
  int   x1;		//ࠧ ⨭ ( ࠭)
  int   y1;
  int   x2;
  int   y2;
  int   hres;		//⨪쭮  ਧ⠫쭮 ࠧ襭
  int   vres;		//ᯫ,  ஬ ᮧ ࠦ
unsigned char  clrma[48];	//
  char  vmode;		//
  char  nplanes;	//⢮ ᪮⥩ ( ᨨ 2.5 = 0)
  int   bplin;		//  ப
  int   palinfo;	// (1-梥⭠, 2-୮-)
  int   shres;		//ࠧ襭 ᪠
  int   svres;
  char  xtra[54];	//१ࢭ  (䨫)
};// -------------   䠩 ଠ .PCX -------------


 int  op = COPY;			//᪠   㬮砭
 FILE  *fp = NULL;			//⮪ ᭮ 䠩



// ============ ⠭ ᪮ 樨 =================
void setOperation(int operation)
{  op = operation; }
// =========  ⠭ ᪮ 樨 ==============






// ================ ⠭ ॣ஢ ========================
void  openScreen(unsigned char color)
{ SetReg(GDC, GDCReset, color);		// 梥  ॣ set/reset
  SetReg(GDC, GDCEnable, 0x0F);         //⨥ ᪮⥩  
  SetReg(GDC, GDCDataRotate, op<<3);    //᪠   梥⮬
} // =============  ⠭ ॣ஢ ===================







// ========== ⠭ ॣ஢  㬮砭 ==================
void  closeScreen(void)
{ SetReg(GDC, GDCBitMask, 0xFF);     	//᪠ ⮢  㬮砭
  SetReg(GDC, GDCEnable, 0x00);         //⨥ ᪮⥩  
  SetReg(GDC, GDCDataRotate, COPY);  //᪠   㬮砭
}// ========  ⠭ ॣ஢  㬮砭 ==============







// ============  梥 ࠬ ࠭ ===============
void setOverscan(unsigned char i)
{ union REGS  r;
  r.h.ah = 0x10;
  r.h.al = 1;
  r.h.bh = i;
  int86(0x10, &r, &r);
} // ==========   梥 ࠬ ࠭ ===========






// ===============  ⥪饩  =================
void getColor(unsigned char *colorBuf)	//colorBuf -   
{ union REGS  r;
  for (int i=0;i<=15;i++)
    { r.h.ah = 0x10;		//⥭ ॣ 
      r.h.al = 7;
      r.h.bl = i;
     int86(0x10, &r, &r);
      r.h.ah = 0x10;		//⥭ ॣ DAC
      r.h.al = 0x15;
      r.h.bl = r.h.bh;
      r.h.bh = 0;
     int86(0x10, &r, &r);
      colorBuf[3*i] = r.h.dh;		//
      colorBuf[3*i+1] = r.h.ch;		//
      colorBuf[3*i+2] = r.h.cl;		//ᨭ
    }
} // ===============   ⥪饩  =================







// =============      ࠭ =============
void setColor(unsigned char *colorBuf)	//colorBuf -  
{ union REGS  r;
  for (int i=0;i<=15;i++)
    { r.h.ah = 0x10;		//⥭ ॣ 
      r.h.al = 7;
      r.h.bl = i;
     int86(0x10, &r, &r);
      setrgbpalette(r.h.bh,
		    colorBuf[3*i],
		    colorBuf[3*i+1],
		    colorBuf[3*i+2]);
    }
} // =========       ࠭ ==========







// ===========     梥 ===========
void setColorOne(unsigned char *colorBuf,	// 
		 int i)				// 梥
{ union REGS  r;
      r.h.ah = 0x10;		//⥭ ॣ 
      r.h.al = 7;
      r.h.bl = i;
     int86(0x10, &r, &r);
      setrgbpalette(r.h.bh,
		    colorBuf[3*i],
		    colorBuf[3*i+1],
		    colorBuf[3*i+2]);
} // =======      梥 =======








// ============== ⠭ 㪠⥫  ⨭ ==================
int PosPoint(char *nfile,	// ᭮ 䠩
	     int picN,		// ⨭
	     char *picFile)	//䠩 ⨭
{  extern FILE *fp;		//⮪  ᭮ 䠩
   char sign2[] = "bbb";	//2-  ᨣ ⨭
   char sign1[] = "aaa";	//1-  ᨣ ⨭
   char buf1[4], buf2[4];	//  뢠 ᨣ
   int numPic=0;		//  ⨭
   FILE *in;			//⮪  ⨭
// ---------  ᨣ ----------
  if(fp==NULL) fp=fopen(nfile,"r+b");
  if(fp==NULL) {printf("  %s  !\n",nfile); return 1;}
 int flagL=2; if(ftell(fp)==0) flagL=1;
   while(flagL>0)
  { numPic = -1;
    fread(&buf1, 1, 1, fp);
    if (feof(fp)!=0) {if(--flagL>0) fp=fopen(nfile,"r+b"); continue;}
    if (buf1[0]==sign1[0])
      {	fseek(fp, -1, SEEK_CUR);
	fread(&buf1, 1, 3, fp);
	fread(&buf2, 1, 3, fp);
	fread(&numPic, 2, 1, fp);	//뢠  ⨭
	buf1[3] = 0; buf2[3] = 0;	//-ᨬ
    // ----- ᨣ? -----
     if(!strcmp(buf1, sign1) && !strcmp(buf2, sign2) && numPic==picN)
       return 0;
     else
       if(feof(fp)!=0) {if(--flagL>0) fp=fopen(nfile,"r+b"); continue;}
	fseek(fp, -7, SEEK_CUR);	// 㪠⥫
      }
  }
    if (numPic==-1)	//᫨  ᨣ
      {  // --------  ᨣ ----------
	fseek(fp, 0L, SEEK_END);	//㪠⥫ ->  䠩
	fwrite(&sign1, 1, 3, fp);	// 1  ᨣ
	fwrite(&sign2, 1, 3, fp);	// 2  ᨣ
	fwrite(&picN, 2, 1, fp);	//  ⨭
	long strmP = ftell(fp);		// 砫 ⨭
       if((in = fopen(picFile, "r+b"))==NULL)	//⨥ 䠩 ⨭
	 {printf("    %s\n", picFile); return 1;}
	  // ------  䠩 ⨭ -------
       for (;;)
	{ fread(&buf1, 1, 1, in);
	  if (feof(in)!=0)  break;
	  fwrite(&buf1, 1, 1, fp);
	}
     fclose(in);
     fseek(fp, strmP, SEEK_SET);
      }
   return 0;
} // ===========  ⠭ 㪠⥫  ⨭ ==============








// ================ 뢮 ப ᥫ  ࠭ ===============
void  LinePixel
(unsigned char far *planes,	//㪠⥫ 
	  int  widthStr,	//  ப
	  int  skipByte,	//᪮쪮 ⮢ ய
 unsigned char beginMask,	//砫쭠 ᪠
	  int  fullByte,	//᪮쪮 ⮢ 뢥
 unsigned char endMask,		//筠 ᪠
 unsigned int x,		// ப  ࠭
 unsigned int y
)
{ unsigned char far *pl;	//⥪騩 㪠⥫  ப
  unsigned char far *m;		//⥪騩 㪠⥫  
  unsigned char far *strBeg;	//砫 ப  
  unsigned int  k;		//ࠡ ६
  unsigned char c;		//ࠡ ६
  int npl = 4;			//᫮ ᪮⥩
 strBeg = MemoryOf(x, y);  //砫 ப   ( ࠭ )
// ------  ப ᥫ  ࠭ 梥⮬ 䮭 -------
  pl=planes+skipByte; m=strBeg; setOperation(COPY); openScreen(0);
  if (beginMask!=0)  {SetMask(beginMask); c=*m; *m=0; m++; pl++;}
  for(k=0; k<fullByte; k++)  {SetMask(0xFF); c=*m; *m=0; m++; pl++;}
  if (endMask!=0)  {SetMask(endMask); c=*m;  *m=0;}
// ---------- 뢮  㫥 ᪮ -----------
  pl=planes+skipByte; m=strBeg; setOperation(COPY); openScreen(1);
  if (beginMask!=0)  {SetMask(*pl & beginMask); c=*m; *m=0; m++; pl++;}
  for(k=0; k<fullByte; k++)  {SetMask(*pl); c=*m; *m=0; m++; pl++;}
  if (endMask!=0)  {SetMask(*pl & endMask);  c=*m; *m=0;}
// ---------- 뢮   ᪮ -----------
 if(npl>1)
 {pl=planes+skipByte+widthStr; m=strBeg; setOperation(OR); openScreen(2);
  if (beginMask!=0)  {SetMask(*pl & beginMask); c=*m; *m=0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SetMask(*pl);  c=*m; *m=0; m++; pl++;}
  if (endMask!=0)  {SetMask(*pl & endMask);  c=*m; *m=0;}
 }
// ---------- 뢮   ᪮ -----------
 if(npl>2)
 {pl=planes+skipByte+2*widthStr; m=strBeg; openScreen(4);
  if (beginMask!=0)  {SetMask(*pl & beginMask); c=*m; *m=0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SetMask(*pl);  c=*m; *m=0; m++; pl++;}
  if (endMask!=0)  {SetMask(*pl & endMask);  c=*m;  *m=0;}
 }
// ---------- 뢮   ᪮ -----------
 if(npl>3)
 {pl=planes+skipByte+3*widthStr; m=strBeg; openScreen(8);
  if (beginMask!=0)  {SetMask(*pl & beginMask); c=*m; *m=0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SetMask(*pl);  c=*m; *m=0; m++; pl++;}
  if (endMask!=0)  {SetMask(*pl & endMask);  c=*m; *m=0;}
 }
   setOperation(COPY);
   openScreen(1);
   closeScreen();
   c = c;		//⮡  Warning  樨
} // ============  뢮 ப ᥫ  ࠭ ==============







// =====================  .PCX ========================
static  PCXheader  ph;		//६  䠩 .PCX



// ======== 뢠    .PCX =========
int   headerPCX(FILE *fp,		// ⮪
	  unsigned char far* pic,	//쭮  obj-䠩
	  PCXheader  *ph,		//
	  unsigned char *colorBuf)	//  
{ union REGS  r;
  int i=0;			//ࠡ ६
// --- 뢠  䠩 ---
 if(fp==NULL) for(i=0;i<sizeof(PCXheader);i++) *((char far*)ph+i)=pic[i];
  else fread(ph, sizeof(PCXheader), 1, fp);
// ----- 饬 த .PCX ------
 if(ph->encod>1||ph->bitpx<1||ph->bitpx>2||ph->nplanes<0||ph->nplanes>4)
   return 1;
// --------- ⥭  ------------
  for(i=0;i<=15;i++)
    { r.h.ah=0x10; r.h.al=7; r.h.bl=i; int86(0x10,&r,&r);
      colorBuf[3*i]=(ph->clrma[3*i])>>=2;
      colorBuf[3*i+1]=(ph->clrma[3*i+1])>>=2;
      colorBuf[3*i+2]=(ph->clrma[3*i+2])>>=2;
    }
  return 0;
} // =====  뢠    .PCX =====





// ============== 뢮 ⨭ .PCX  ࠭ ===============
int  writePCX(FILE *fp,		// ⮪
	unsigned char far* pic,	//쭮  obj-䠩
	PCXheader ph,		//㪠⥫ 
	int xS=0, int yS=0,	// ࠣ  ࠭
	int dx=0, int dy=0,	//ᬥ饭 ࠣ
	int dw=-1, int dh=-1)	//ਭ   ࠣ
{
   int    skipByte,		//᪮쪮 ⮢ ய
	  fullByte;		//᫮  ⮢
unsigned char beginMask,	//砫쭠 ᪠
	      endMask;		//筠 ᪠
   int k,			//ࠡ. ६
       n,			// ப   (㬬ୠ)
       y,			//⥪ ப
       l,			//ࠡ ६
       rep_count = 0;		//稪  ⮢
  unsigned char *planes;	//  ᯠ ப
  unsigned char	   c,		//࠭⥫ 
		bits;		//࠭⥫ ⮢
   int Width;			//᫮ ⮢  ப

   n = ph.nplanes * ph.bplin;	//᫮ ᪮⥩ * ᫮ ⮢  ப
  planes = (unsigned char*)malloc(n+4);  //  ᯠ ப
  Width = ph.bplin;		//᫮ ⮢  ப
// -------  室   ⨬ --------
    if(dw==-1) dw=ph.x2-ph.x1+1; if(dh==-1) dh=ph.y2-ph.y1+1;
    if (dw<0 || dh<0)  return 2;
    if (dx<0)
      { if (dw+dx<=0) return 2;  else {dw+=dx; dx = 0;} }
    if (dy<0)
      { if (dh+dy<=0) return 2;  else {dh+=dy; dy = 0;} }
  if (xS+dw>getmaxx()+1)  dw=getmaxx()-xS;
  if (yS+dh>getmaxy()+1)  dh=getmaxy()-yS;
  if (xS>getmaxx() || yS>getmaxy())  return 2;
   if (xS<0)
     if (dw+xS>0)  {dw+=xS;  dx-=xS; xS=0;}  else return 2;
  if (dw>(ph.x2-ph.x1+1)-dx)  dw = (ph.x2-ph.x1+1)-dx;
// ---------- । 稪  ᮪ -------------
   skipByte = ((ph.x1 & 0x7)+dx) >> 3;		//ய ⮢
   beginMask = 0xFF>>(xS & 0x7);		//砫쭠 ᪠
   fullByte = (dw-(8-(xS & 0x7))) >> 3;		//᫮  ⮢
   endMask = 0xFF << (8-((xS+dw) & 0x7));	//筠 ᪠
// --------- 뢮 ࠦ ---------
   long i=sizeof(PCXheader);
   for (y=0; y<=ph.y2-ph.y1; y++)
 {   k = 0;
     while (k<n)		// ᯠ  ப
      {  if(fp==NULL) c=*(pic+i++); else fread(&c, 1, 1, fp);
	 if ((c & 0xC0)==0xC0)
	   { rep_count = (c & 0x3F);
	     if(fp==NULL) bits=*(pic+i++); else fread(&bits, 1, 1, fp);
	   }
	 else  { rep_count = 1; bits = c; }
	for (l=0; l<rep_count; l++)  { planes[k+l] = bits; }
	k+=rep_count;
      }
    if (y>=dy+dh || y>getmaxy()-yS-dy)  break;
 if (y>=dy)
  {
   l = ((ph.x1+dx) & 0x7) - (xS & 0x7);	//ᬥ饭  (ph.x1+dx)  xS
// --------- ᤢ 뢮 ப  稭 ᬥ饭 ----------
  if (l>0)			//ᤢ   l ᥫ
    { c = 0xFF<<(8-l);
      for (k=0; k<n; k++)
       { planes[k] <<= l;
	 bits = planes[k+1] & c;
	 planes[k] |= (bits >>= (8-l));
       }
    }
  if (l<0)			//ᤢ ࠢ  l ᥫ
    { c = 0xFF>>(8+l);
      for (k=n+2; k>=0; k--)
       { bits = (planes[k] & c);
	 planes[k+1] |= (bits <<= (8+l));
	 planes[k] >>= -l;
       }
    }
   LinePixel(planes,Width,skipByte,beginMask,fullByte,endMask,xS,yS+y-dy);
  }
 }
// ------ ⮢  室 --------
   setOperation(COPY);
   openScreen(1);
   closeScreen();
   free(planes);
   return 0;
} // =========  뢮 ⨭ .PCX  ࠭ ========






// =============== 뢮   ⨭ .PCX ===============
// 頥:	0 - ᯥ譮 襭, 1 - ਩;
int  getPCX(FILE *fp,		// ⮪
      unsigned char far* pic,	//쭮  obj-䠩
      PCXheader ph,		//
      unsigned char huge *Buf,	//㪠⥫ 
      int dx=0, int dy=0,	//ᬥ饭 ࠣ ( ᥫ)
      int dw=-1, int dh=-1)	//ਭ   ࠣ ( ᥫ)
{
   int  skipByte;		//᪮쪮 ⮢ ய
   int  dwPl;			//᫮ ⮢   ᪮
unsigned long  skB = 0;		//⥪騩 㪠⥫  
   int k,			//ࠡ. ६
       n,			// ப   (㬬ୠ)
       y,			//⥪ ப
       l,			//ࠡ ६
       rep_count = 0;		//稪  ⮢
  unsigned char *planes;	//  ᯠ ப
  unsigned char	c, bits;	//࠭⥫ 
 if(dw==-1) dw=ph.x2-ph.x1+1; if(dh==-1) dh=ph.y2-ph.y1+1; //ࠧ  㬮.
   n = ph.nplanes * ph.bplin;	//᫮ ᪮⥩ * ᫮ ⮢  ப
  planes = (unsigned char*)malloc(n+4);    //  ᯠ ப
   dwPl = (dw + 7) >> 3;	//᫮ ⮢  ப ࠣ
   skipByte = ((ph.x1 & 0x7)+dx) >> 3;		//ய ⮢
// ---------    ࠧ஢ ࠦ ------------
     Buf[0]=(char)(dw-1);		//.   ࠦ
     Buf[1]=(char)((dw-1)>>8);		//.   ࠦ
     Buf[2]=(char)(dh-1);		//.  ਭ ࠦ
     Buf[3]=(char)((dh-1)>>8);          //.  ਭ ࠦ
     skB = 4;				//. ⠭ 㪠.  
// ---------  ப ࠦ ---------
   long i=sizeof(PCXheader);
   for (y=0; y<=ph.y2-ph.y1; y++)
 {   k = 0;
     while (k<n)		// ᯠ  ப
      {  if(fp==NULL) c=*(pic+i++); else fread(&c, 1, 1, fp);
	 if ((c & 0xC0)==0xC0)
	   { rep_count = (c & 0x3F);
	     if(fp==NULL) bits=*(pic+i++); else fread(&bits, 1, 1, fp);
	   }
	 else  { rep_count = 1; bits = c; }
	for (l=0; l<rep_count; l++)  { planes[k+l] = bits; }
	k+=rep_count;
      }
     if (y>=dy+dh)   break;
 if (y>=dy)
  {
   l = (ph.x1+dx) & 0x7;	//ᬥ饭 (ph.x1+dx)  ࠭ 
// --------- ᤢ ப   l ᥫ ----------
  if (l>0)
    { c = 0xFF<<(8-l);
      for (k=0; k<n; k++)
       { planes[k] <<= l;
	 bits = planes[k+1] & c;
	 planes[k] |= (bits >>= (8-l));
       }
    }
// ------- ᬥ 浪 ᪮⥩ ( putimage()) -------
  for (int j=0; j<ph.bplin; j++)
   { bits = planes[j];
     c = planes[ph.bplin+j];
     planes[j] = planes[3*ph.bplin+j];
     planes[ph.bplin+j] = planes[2*ph.bplin+j];
     planes[3*ph.bplin+j] = bits;
     planes[2*ph.bplin+j] = c;
   }
// ------------- ᥭ   ப ࠦ ---------------
  for (j=0; j<=3; j++)
   { int jj = j*ph.bplin+skipByte;
     for (int i=0; i<dwPl; i++)   Buf[skB+i] = planes[jj+i];
     skB += dwPl;
   }
  }
 } // ------ ⮢  室 --------
   setOperation(COPY);
   openScreen(1);
   closeScreen();
   free(planes);
   return 0;
} // ===========  뢮 ⨭ .PCX   ==========

